<!DOCTYPE html>
<html>
<head>
    <title>CRUD Province</title>
    <meta charset="utf-8">
    <meta name="viewport" content="width=device-width, initial-scale=1">
    <link rel="stylesheet" href="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/css/bootstrap.min.css">
    <script src="https://ajax.googleapis.com/ajax/libs/jquery/3.5.1/jquery.min.js"></script>
    <script src="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/js/bootstrap.min.js"></script>

    <!-- Import Datatable sau jquery -->
    <!-- Import them style bootstrap cho datatable -->
    <link rel="stylesheet" href="https://cdn.datatables.net/1.10.24/css/dataTables.bootstrap4.min.css">
    <script src="https://cdn.datatables.net/1.10.24/js/jquery.dataTables.min.js"></script>
    <script src="https://cdn.datatables.net/1.10.24/js/dataTables.bootstrap4.min.js"></script>
</head>
<body>
    <div class="jumbotron">
        <h1 class="text-center">THÔNG TIN TỈNH/THÀNH</h1>
        <div class="row form-group">
            <div class="col-sm-4">
                <label>Tên Tỉnh/Thành</label>
            </div>
            <div class="col-sm-8">
                <select id="select-province" class="form-control">
                    <option value="0">Chọn Tỉnh/Thành</option>
                </select>
            </div>
        </div>
        <div class="row form-group">
            <div class="col-sm-4">
                <label>Tên Quận/Huyện</label>
            </div>
            <div class="col-sm-8">
                <select id="select-district" class="form-control">
                    <option value="0">Chọn Quận/Huyện</option>
                </select>
            </div>
        </div>
        <div class="row form-group">
            <div class="col-sm-4">
                <label>Tên Phường/Xã</label>
            </div>
            <div class="col-sm-8">
                <select id="select-ward" class="form-control">
                    <option value="0">Chọn Phường/Xã</option>
                </select>
            </div>
        </div>
    </div>
    <div class="container">
        <h2 class="text-center">Tạo mới/Chỉnh sửa</h2>
        <div class="row">
            <div class="col-sm-4 border border-danger">
                <h3>Tỉnh/Thành</h3>
                <div class="row form-group">
                    <div class="col-sm-4">
                        <label>Tên</label>
                    </div>
                    <div class="col-sm-8">
                        <input id="inp-province-name" class="form-control"/>
                    </div>
                </div>
                <div class="row form-group">
                    <div class="col-sm-4">
                        <label>Mã</label>
                    </div>
                    <div class="col-sm-8">
                        <input id="inp-province-code" class="form-control"/>
                    </div>
                </div>
                <div class="row form-group">
                    <button id="btn-add-province" class="btn btn-primary w-25 form-control">Add</button>
                    <button id="btn-cancel-province" class="btn btn-secondary w-25 form-control">Cancel</button>
                    <button id="btn-update-province" class="btn btn-success w-25 form-control">Update</button>
                    <button id="btn-delete-province" class="btn btn-danger w-25 form-control">Delete</button>
                </div>
            </div>
            <div class="col-sm-4 border border-danger">
                <h3>Quận/Huyện</h3>
                <div class="row form-group">
                    <div class="col-sm-4">
                        <label>Tên</label>
                    </div>
                    <div class="col-sm-8">
                        <input id="inp-district-name" class="form-control"/>
                    </div>
                </div>
                <div class="row form-group">
                    <div class="col-sm-4">
                        <label>Tỉnh/Thành</label>
                    </div>
                    <div class="col-sm-8">
                        <select id="select-province-2" class="form-control">
                            <option value="0">Chọn Tỉnh/Thành</option>
                        </select>
                    </div>
                </div>
                <div class="row form-group">
                    <button id="btn-add-district" class="btn btn-primary w-25 form-control">Add</button>
                    <button id="btn-cancel-district" class="btn btn-secondary w-25 form-control">Cancel</button>
                    <button id="btn-update-district" class="btn btn-success w-25 form-control">Update</button>
                    <button id="btn-delete-district" class="btn btn-danger w-25 form-control">Delete</button>
                </div>
            </div>
            <div class="col-sm-4 border border-danger">
                <h3>Phường/Xã</h3>
                <div class="row form-group">
                    <div class="col-sm-4">
                        <label>Tên</label>
                    </div>
                    <div class="col-sm-8">
                        <input id="inp-ward-name" class="form-control"/>
                    </div>
                </div>
                <div class="row form-group">
                    <div class="col-sm-4">
                        <label>Tỉnh/Thành</label>
                    </div>
                    <div class="col-sm-8">
                        <select id="select-province-3" class="form-control">
                            <option value="0">Chọn Tỉnh/Thành</option>
                        </select>
                    </div>
                </div>
                <div class="row form-group">
                    <div class="col-sm-4">
                        <label>Quận/Huyện</label>
                    </div>
                    <div class="col-sm-8">
                        <select id="select-district-2" class="form-control">
                            <option value="0">Chọn Phường/Xã</option>
                        </select>
                    </div>
                </div>
                <div class="row form-group">
                    <button id="btn-add-ward" class="btn btn-primary w-25 form-control">Add</button>
                    <button id="btn-cancel-ward" class="btn btn-secondary w-25 form-control">Cancel</button>
                    <button id="btn-update-ward" class="btn btn-success w-25 form-control">Update</button>
                    <button id="btn-delete-ward" class="btn btn-danger w-25 form-control">Delete</button>
                </div>
            </div>
        </div>
    </div>
</body>
<script>
    $(document).ready(function() {
        var gIdProvince = 0;
        var gIdProvince2 = 0;
        var gIdProvince3 = 0;
        var gIdWard = 0;
        var gArrayProvince;
        var gArrayProvinceById;
        var gIdDistrict = "";
        var gArrayDistrict = [];
        var gCodeProvince = "";
        var gNameProvince = "";
        var gCodeProvince2 = "";
        var gNameProvince2 = "";
        var gCodeProvince3 = "";
        var gNameProvince3 = "";
        var gArrayWard = [];
        onPageLoading();
        $('#select-province').on('change', function() {
            onChangeProvinceSelect(this);
        });
        $('#btn-add-province').on('click', onBtnAddProvinceClick);
        $('#btn-cancel-province').on('click', onBtnCancelProvinceClick);
        $('#btn-update-province').on('click', onBtnUpdateProvinceClick);
        $('#btn-delete-province').on('click', onBtnDeleteProvinceClick);
        $('#select-district').on('change', function() {
            onChangeDistrictSelect(this);
        });
        $('#select-province-2').on('change', function() {
            onChangeProvinceSelect2(this);
        });
        $('#btn-add-district').on('click', onBtnAddDistrictClick);
        $('#btn-cancel-district').on('click', onBtnCancelDistrictClick);
        $('#btn-update-district').on('click', onBtnUpdateDistrictClick);
        $('#btn-delete-district').on('click', onBtnDeleteDistrictClick);
        $('#select-province-3').on('change', function() {
            onChangeProvinceSelect3(this);
        });
        $('#select-ward').on('change', function() {
            onChangeWardSelect(this);
        });
        $('#btn-add-ward').on('click', onBtnAddWardClick);
        $('#btn-cancel-ward').on('click', onBtnCancelWardClick);
        $('#btn-update-ward').on('click', onBtnUpdateWardClick);
        $('#btn-delete-ward').on('click', onBtnDeleteWardClick);
        function reloadPage() {
            location.reload();
        }
        function onPageLoading() {
            loadDataToSelectProvince();
        }
        function loadDataToSelectProvince() {
            $.ajax({
                url: "http://localhost:8080/provinces",
                type: "GET",
                dataType: "json",
                async: false,
                success: function(res) {
                    console.log(res);
                    gArrayProvince = res;
                    for (var i = 0; i < res.length; i++) {
                        $('#select-province').append($('<option>').val(res[i].code).text(res[i].name));
                        $('#select-province-2').append($('<option>').val(res[i].code).text(res[i].name));
                        $('#select-province-3').append($('<option>').val(res[i].code).text(res[i].name));
                        $('#inp-province-name').val("");
                        $('#inp-province-code').val("");
                        $("#select-province").find('option:eq(0)').prop('selected', true);
                        $("#select-province-2").find('option:eq(0)').prop('selected', true);
                        $("#select-province-3").find('option:eq(0)').prop('selected', true);
                    }
                },
                error: function(error) {
                    console.log(error.responseText);
                }
            });  
        }
        function onChangeProvinceSelect(paramEle) {
            console.log(paramEle);
            gCodeProvince = $(paramEle).val();
            gNameProvince = $("#select-province option:selected").text();
            console.log(gCodeProvince);
            console.log(gNameProvince);
            $('#inp-province-name').val(gNameProvince);
            $('#inp-province-code').val(gCodeProvince);
            $("#select-district-2").html("");
            for (var i = 0; i < gArrayProvince.length; i++) {
                if (gCodeProvince == gArrayProvince[i].code) {
                    gIdProvince = gArrayProvince[i].id;
                }
            }
            $("#select-province-2").find('option:eq(' + gIdProvince + ')').prop('selected', true);
            $("#select-province-3").find('option:eq(' + gIdProvince + ')').prop('selected', true);
            $('#select-district').html("");
            loadDataToSelectDistrict();
        }
        function onBtnAddProvinceClick() {
            var vProvinceObj = {
                name: "",
                code: "",
            }
            vProvinceObj.code = $('#inp-province-code').val();
            vProvinceObj.name = $('#inp-province-name').val();
            console.log(vProvinceObj);
            if (vProvinceObj.code != null && vProvinceObj.name != null) {
                $.ajax({
                    url: "http://localhost:8080/provinces",
                    type: "POST",
                    data: JSON.stringify(vProvinceObj),
                    async: false,
                    contentType: "application/json",
                    success: function(res) {
                        reloadPage();
                    },
                    error: function(error) {
                        console.log(error.responseText);
                    }
                });
            }
        }
        function onBtnCancelProvinceClick() {
            $('#inp-province-name').val("");
            $('#inp-province-code').val("");
        }
        function onBtnUpdateProvinceClick() {
            var vProvinceObj = {
                name: "",
                code: "",
            }
            vProvinceObj.code = $('#inp-province-code').val();
            vProvinceObj.name = $('#inp-province-name').val();
            var vCodeProvince = $('#inp-province-code').val();
            $.ajax({
                url: "http://localhost:8080/provinces/" + gIdProvince,
                type: "PUT",
                data: JSON.stringify(vProvinceObj),
                async: false,
                contentType: "application/json",
                success: function(res) {
                    reloadPage();
                },
                error: function(error) {
                    console.log(error.responseText);
                }
            });
        }
        function onBtnDeleteProvinceClick() {
            $.ajax({
                url: "http://localhost:8080/provinces/" + gIdProvince,
                type: "DELETE",
                async: false,
                success: function(res) {
                    reloadPage();
                },
                error: function(error) {
                    console.log(error.responseText);
                }
            });
        }
        function loadDataToSelectDistrict() {
            $.ajax({
                url: "http://localhost:8080/districts",
                type: "GET",
                dataType: "json",
                async: false,
                success: function(res) {
                    console.log(res);
                    for (var i = 0; i < res.length; i++) {
                        if (res[i].province.id == gIdProvince) {
                            $('#select-district').append($('<option>').val(res[i].id).text(res[i].name));
                            $('#select-district-2').append($('<option>').val(res[i].id).text(res[i].name));
                        }    
                    }
                },
                error: function(error) {
                    console.log(error.responseText);
                }
            });
        }
        function onChangeDistrictSelect(paramEle) {
            gIdDistrict = $(paramEle).val();
            var vNameDistrict = $("#select-district option:selected").text();
            console.log(gIdDistrict);
            console.log(vNameDistrict);
            $('#select-ward').html("");
            $('#inp-district-name').val(vNameDistrict);
            $('#select-district-2 option[value=' + gIdDistrict + ']').attr('selected','selected');
            $.ajax({
                url: "http://localhost:8080/wards",
                type: "GET",
                dataType: "json",
                async: false,
                success: function(res) {
                    gArrayWard = [];
                    for (var i = 0; i < res.length; i++) {
                        if (res[i].district.id == gIdDistrict) {
                            gArrayWard.push(res[i]);
                        }
                    }
                    console.log(gArrayWard);
                    loadDataToSelectWard();
                },
                error: function(error) {
                    console.log(error.responseText);
                }
            });
        }
        function onChangeProvinceSelect2(paramEle) {
            gCodeProvince2 = $(paramEle).val();
            gNameProvince2 = $("#select-province-2 option:selected").text();
            for (var i = 0; i < gArrayProvince.length; i++) {
                if (gCodeProvince2 == gArrayProvince[i].code) {
                    gIdProvince2 = gArrayProvince[i].id;
                }
            }
            console.log(gIdProvince2);
        }
        function onBtnAddDistrictClick() {
            var vDistrictObj = {
                name: "",
                province: {
                    id: "",
                    code: "",
                    name: "",
                }
            };
            vDistrictObj.name = $('#inp-district-name').val();
            vDistrictObj.province.id = gIdProvince2;
            vDistrictObj.province.code = gCodeProvince2;
            vDistrictObj.province.name = gNameProvince2;
            if (vDistrictObj.province.code == "") {
                vDistrictObj.province.id = gIdProvince;
                vDistrictObj.province.code = gCodeProvince;
                vDistrictObj.province.name = gNameProvince;
            }
            console.log(vDistrictObj);
            $.ajax({
                url: "http://localhost:8080/districts",
                type: "POST",
                data: JSON.stringify(vDistrictObj),
                contentType: "application/json",
                async: false,
                success: function(res) {
                    reloadPage();
                },
                error: function(error) {
                    console.log(error.responseText);
                }
            });
        }
        function onBtnCancelDistrictClick() {
            $('#inp-district-name').val("");
            $("#select-province-2").find('option:eq(0)').prop('selected', true);
        }
        function onBtnUpdateDistrictClick() {
            var vDistrictObj = {
                name: "",
                province: {
                    id: "",
                    code: "",
                    name: "",
                },
                id: "",
            };
            vDistrictObj.name = $('#inp-district-name').val();
            vDistrictObj.id = gIdDistrict;
            vDistrictObj.province.id = gIdProvince2;
            vDistrictObj.province.code = gCodeProvince2;
            vDistrictObj.province.name = gNameProvince2;
            if (vDistrictObj.province.code == "") {
                vDistrictObj.province.id = gIdProvince;
                vDistrictObj.province.code = gCodeProvince;
                vDistrictObj.province.name = gNameProvince;
            }
            console.log(vDistrictObj);
            $.ajax({
                url: "http://localhost:8080/districts/" + gIdDistrict,
                type: "PUT",
                data: JSON.stringify(vDistrictObj),
                contentType: "application/json",
                async: false,
                success: function(res) {
                    reloadPage();
                },
                error: function(error) {
                    console.log(error.responseText);
                }
            });
        }
        function onBtnDeleteDistrictClick() {
            $.ajax({
                url: "http://localhost:8080/districts/" + gIdDistrict,
                type: "DELETE",
                async: false,
                success: function(res) {
                    reloadPage();
                },
                error: function(error) {
                    console.log(error.responseText);
                }
            });
        }
        function loadDataToSelectWard() {
            for (var i = 0; i < gArrayWard.length; i++) {
                $('#select-ward').append($('<option>').val(gArrayWard[i].id).text(gArrayWard[i].name));
            }
        }
        function onChangeProvinceSelect3(paramEle) {
            console.log(paramEle);
            gCodeProvince3 = $(paramEle).val();
            gNameProvince3 = $("#select-province option:selected").text();
            for (var i = 0; i < gArrayProvince.length; i++) {
                if (gCodeProvince3 == gArrayProvince[i].code) {
                    gIdProvince3 = gArrayProvince[i].id;
                }
            }
            $('#select-district-2').html("");
            loadDataToSelectDistrict2();
        }
        function loadDataToSelectDistrict2() {
            $.ajax({
                url: "http://localhost:8080/districts",
                type: "GET",
                dataType: "json",
                async: false,
                success: function(res) {
                    for (var i = 0; i < res.length; i++) {
                        if (res[i].province.id == gIdProvince3) {
                            $('#select-district-2').append($('<option>').val(res[i].id).text(res[i].name));
                        }    
                    }
                },
                error: function(error) {
                    console.log(error.responseText);
                }
            });
        }
        function onChangeWardSelect(paramEle) {
            gIdWard = $(paramEle).val();
            var vNameWard = $("#select-ward option:selected").text();
            $('#inp-ward-name').val(vNameWard);
        }
        function onBtnAddWardClick() {
            var vWardObj = {
                name: "",
                district: {
                    name: "",
                    id: "",
                    province: {
                        id: "",
                        name: "",
                        code: ""
                    }
                }
            };
            vWardObj.name = $('#inp-ward-name').val();
            vWardObj.district.name = $('#select-district-2 option:selected').text();
            vWardObj.district.id = $('#select-district-2 option:selected').val();
            vWardObj.district.province.id = gIdProvince3;
            vWardObj.district.province.code = $('#select-province-3 option:selected').val();
            vWardObj.district.province.name = $('#select-province-3 option:selected').text();
            console.log(vWardObj);
            $.ajax({
                url: "http://localhost:8080/wards",
                type: "POST",
                data: JSON.stringify(vWardObj),
                async: false,
                contentType: "application/json",
                success: function(res) {
                    reloadPage();
                },
                error: function(error) {
                    console.log(error.responseText);
                }
            });
        }
        function onBtnCancelWardClick() {
            reloadPage();
        }
        function onBtnUpdateWardClick() {
            var vWardObj = {
                name: "",
                district: {
                    name: "",
                    id: "",
                    province: {
                        id: "",
                        name: "",
                        code: ""
                    }
                }
            };
            vWardObj.name = $('#inp-ward-name').val();
            vWardObj.district.name = $('#select-district-2 option:selected').text();
            vWardObj.district.id = $('#select-district-2 option:selected').val();
            vWardObj.district.province.id = gIdProvince3;
            vWardObj.district.province.code = $('#select-province-3 option:selected').val();
            vWardObj.district.province.name = $('#select-province-3 option:selected').text();
            $.ajax({
                url: "http://localhost:8080/wards/" + gIdWard,
                type: "PUT",
                data: JSON.stringify(vWardObj),
                async: false,
                contentType: "application/json",
                success: function(res) {
                    reloadPage();
                },
                error: function(error) {
                    console.log(error.responseText);
                }
            });
        }
        function onBtnDeleteWardClick() {
            $.ajax({
                url: "http://localhost:8080/wards/" + gIdWard,
                type: "DELETE",
                async: false,
                success: function(res) {
                    reloadPage();
                },
                error: function(error) {
                    console.log(error.responseText);
                }
            });
        }
    });
</script>
</html>